#include "predef.h"
#include <stdio.h>
#include <ctype.h>
#include <startnet.h>
#include <autoupdate.h>
#include <dhcpclient.h>
#include <NetworkDebug.h>
#include <pins.h>
#include <sim.h>

#define s0 (J2[30]) // SPI CS0 / GPIO
#define s1 (J2[40]) // SPI CS1 / GPIO
#define s2 (J2[35]) // SPI CS2 / GPIO
#define s3 (J2[26]) // SPI CS3 / GPIO
#define in (J2[31]) // Analog i/o ch0


extern "C" {
void UserMain(void * pd);
}

const char * AppName="tsl230r";

DWORD readIn() {
	DWORD buffer = TimeTick; // Buffer holding current TimeTick
	while (buffer+1 > TimeTick);
	sim.timer[0].tcn = 0;
	while (buffer+1+5 > TimeTick);
	buffer = sim.timer[0].tcn; // Buffer holding frequency
	return (buffer*4);
}


void UserMain(void * pd) {
    InitializeStack();
    if (EthernetIP == 0) GetDHCPAddress();
    OSChangePrio(MAIN_PRIO);
    EnableAutoUpdate();
    StartHTTP();

    #ifdef _DEBUG
    InitializeNetworkGDB_and_Wait();
    #endif

    s0.function(PIN_GPIO);
    s1.function(PIN_GPIO);
    s2.function(PIN_GPIO);
    s3.function(PIN_GPIO);
    in.function(PINJ2_31_TIN0);

    s0 = 1;
    s1 = 1;
    s2 = 0;
    s3 = 0;



    /*			Timer0 Configuration
     *  [PS]	- 0x00		No Prescaling
     *  [CE]	- 00		Disable capture event output - Not used
     *  [OM]	- 0			Not using this
     *  [ORRRI]	- 0			Not using interrupts
     *  [FRR]	- 0			Timer continues to increment
     *  [CLK]	- 11		Measuring falling edges on DTIN0 pin
     *  [RST]	- 1			Enable Timer
     *
     *  		= 0x0007
     */

    sim.timer[0].tmr = 0x0007;

    iprintf("Application started\n");
    while (1) {
        int i = readIn();
    	iprintf("freq: %8d\r",i);
    }
}
